与 Svelte 集成
在阅读本指南之前,建议您对 Svelte 有基本的了解。如需快速回顾,请参考 Svelte 文档。
DHTMLX Kanban 可以与 Svelte 顺畅集成。我们提供了示例代码,展示如何在 Svelte 项目中使用 DHTMLX Kanban。如需了解更多细节,请参阅 GitHub 示例。
创建项目
有几种方式可以搭建 Svelte 项目:
- 使用 SvelteKit
或
- 仅使用 Svelte 和 Vite(不使用 SvelteKit):
npm create vite@latest
详细信息可参见此相关文档。
安装依赖
假设项目名为 my-svelte-kanban-app,切换到该目录下:
cd my-svelte-kanban-app
选择您喜欢的包管理工具安装依赖并启动开发服务器:
- 使用 yarn:
yarn
yarn start
- 使用 npm:
npm install
npm run dev
应用随后会在本地启动,通常地址为 http://localhost:3000
。
创建 Kanban
接下来,需要准备好 DHTMLX Kanban 的源代码。此时请先停止应用,然后安装 Kanban 包。
步骤 1. 安装包
下载 试用版 Kanban 包 并按照 README 指南操作。请注意:试用版有效期为 30 天。
步骤 2. 创建组件
现在可以在应用中新增一个包含 Kanban 及工具栏的 Svelte 组件。在 src/ 目录下新建文件 Kanban.svelte。
导入源文件
打开 Kanban.svelte,导入 Kanban 的相关源文件。请注意:
- 如果使用 PRO 版本并从本地包安装,导入路径类似如下:
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>
根据包的不同,源文件可能已被压缩。如果是这种情况,请确保导入 kanban.min.css。
- 如果使用试用版,导入路径如下:
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
<script>
本指南以 试用版 为例进行配置说明。
设置容器并添加 Kanban 与工具栏
要显示 Kanban 和工具栏,需要为这两个组件设置容器,并用构造函数进行初始化:
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
let toolbar_container, kanban_container; // 初始化 Kanban 和 Toolbar 的容器
let kanban, toolbar;
onMount(() => {
// 初始化 Kanban 组件
kanban = new Kanban(kanban_container, {})
// 初始化 Toolbar 组件
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // 提 供 Kanban 内部 API
// 其他配置项
})
});
onDestroy(() => {
kanban.destructor(); // 销毁 Kanban
toolbar.destructor(); // 销毁 Toolbar
});
</script>
<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>
加载数据
要将数据加载到 Kanban,需要准备一个数据集。在 src/ 目录下创建 data.js 文件,并添加示例数据:
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];
const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/kanbans ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];
const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];
return { columns, cards, rows };
}
现在,打开 App.svelte,导入数据,并将其作为 props 传递给新的 <Kanban/>
组件:
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";
const { cards, columns, rows } = getData();
</script>
<Kanban {cards} {columns} {rows} />
然后,在 Kanban.svelte 中使用这些 props 来配置 Kanban:
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar, defaultEditorShape } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export let columns;
export let cards;
export let rows;
let toolbar_container, kanban_container;
let kanban, toolbar;
onMount(() => {
kanban = new Kanban(kanban_container, {
columns,
cards,
rows,
rowKey: "type",
// 其他配置项
})
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // 提供 Kanban 内部 API
// 其他配置项
})
});
onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>
<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>
另外,也可以在 Svelte 的 onMount()
生命周期中使用 parse()
方法为 Kanban 加载数据:
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar} from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export let columns;
export let cards;
export let rows;
let toolbar_container, kanban_container;
let kanban, toolbar;
onMount(() => {
kanban = new Kanban(kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置项
})
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // 提供 Kanban 内部 API
// 其他配置项
})
kanban.parse({ columns, cards, rows });
});
onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>
<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>
使用 parse(data)
方法有助于在数据发生变化时重新加载。
此时,Kanban 组件已经准备就绪。只需将其添加到页面即可自动初始化并载入数据。也可根据实际需求添加其他设置。所有可用选项详见 Kanban API 文档。
处理事件
每当 Kanban 有动作发生时,都会触发相应事件。可通过这些事件响应用户操作并执行自定义逻辑。完整事件列表请查阅 事件总览。
如下代码示例展示如何在 onMount()
中处理事件,请添加到 Kanban.svelte:
<script>
// ...
let kanban;
onMount(() => {
kanban = new Kanban(kanban_container, {})
kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
});
onDestroy(() => {
kanban.destructor();
});
</script>
// ...
步骤 3. 将 Kanban 添加到应用中
要在应用中显示组件,请打开 App.svelte 并更新代码:
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";
const { columns, cards } = getData();
</script>
<Kanban {cards} {columns} {rows} />
现在,启动应用即可看到 Kanban 组件基于所提供数据正常运行。
至此,已将 DHTMLX Kanban 集成到 Svelte 应用中。代码可根据实际需求进行调整。如需进阶示例,请参考 GitHub。

与 Angular 集成
在阅读本指南之前,建议您具备 Angular 的基本知识。如果需要复习,请参考 Angular documentation。
DHTMLX Kanban 可以与 Angular 平滑集成。我们提供了代码示例,演示如何将 DHTMLX Kanban 与 Angular 搭配使用。详细信息可参见 GitHub 示例。
创建项目
在开始新项目之前,请确保已安装 Angular CLI 和 Node.js。
要使用 Angular CLI 创建名为 my-angular-kanban-app 的新项目,只需运行:
ng new my-angular-kanban-app
如果您正在按照本指南操作,在创建 Angular 应用时请关闭服务端渲染 (SSR) 和静态站点生成 (SSG/Prerendering)!
此命令会完成所有必要的设置,无需额外命令。
安装依赖
进入新应用的目录:
cd my-angular-kanban-app
接下来,安装依赖并启动开发服务器。可以使用 yarn 进行如下操作:
yarn
yarn start
您的应用此时应该在本地运行(例如,http://localhost:3000
)。
创建 Kanban
此时,您需要获取 DHTMLX Kanban 的源代码。首先,停止应用并安装 Kanban 包。
步骤 1. 安装包
获取 试用 Kanban 包,并按照 README 中的步骤操作。请注意,试用版有效期为 30 天。
步骤 2. 创建组件
接下来,创建一个 Angular 组件,将 Kanban 及工具栏添加到您的应用。在 src/app/ 下新建 kanban 文件夹,然后添加名为 kanban.component.ts 的新文件。
导入源文件
打开 kanban.component.ts,导入 Kanban 的源文件。导入路径如下:
- 如果是从本地文件夹安装的 PRO 版本:
import { Kanban, Toolbar } from 'dhx-kanban-package';
- 试用版:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
本文档示例采用 trial 版本。
设置容器并初始化 Kanban 和 Toolbar
要显示带有工具栏的 Kanban,需要为两者设置容器,并通过构造函数初始化组件:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';
@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban", // 在 "app.component.ts" 文件中以 <kanban /> 形式引用的模板名
styleUrls: ["./kanban.component.css"], // 包含 CSS 文件
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})
export class KanbanComponent implements OnInit, OnDestroy {
// 初始化 Toolbar 容器
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// 初始化 Kanban 容器
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;
private _kanban!: Kanban;
private _toolbar!: Toolbar;
ngOnInit() {
// 初始化 Kanban 组件
this._kanban = new Kanban(this.kanban_container.nativeElement, {});
// 初始化 Toolbar 组件
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 其他配置项
});
}
ngOnDestroy(): void {
this._kanban.destructor(); // 销毁 Kanban
this._toolbar.destructor(); // 销毁 Toolbar
}
}
添加样式
为确保 Kanban 正确显示,请添加必要的样式。可在 src/app/kanban/ 下新建 kanban.component.css 文件,并包含如下样式:
/* 导入 Kanban 样式 */
@import "@dhx/trial-kanban/dist/kanban.css";
/* 页面初始样式 */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}
/* Kanban 和 Toolbar 容器样式 */
.component_container {
height: 100%;
margin: 0 auto;
}
/* Kanban 容器样式 */
.widget {
height: calc(100% - 56px);
}
加载数据
要向 Kanban 加载数据,请先准备一组数据。在 src/app/kanban/ 下新建 data.ts 文件,并添加您的数据:
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];
const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];
const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];
return { columns, cards, rows };
}
接下来,打开 kanban.component.ts。导入数据文件,并在 ngOnInit()
方法中将数据属性传入 Kanban 的配置:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';
@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})
export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;
private _kanban!: Kanban;
private _toolbar!: Toolbar;
ngOnInit() {
const { cards, columns, rows } = getData(); // 初始化数据属性
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns, // 赋值列数据
cards, // 赋值卡片数据
rows, // 赋值行数据
rowKey: "type",
// 其他配置项
});
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 其他配置项
});
}
ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}
另一种加载数据到 Kanban 的方法是,在 ngOnInit()
方法中使用 parse()
方法。
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';
@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})
export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;
private _kanban!: Kanban;
private _toolbar!: Toolbar;
ngOnInit() {
const { cards, columns, rows } = getData(); // 初始化数据属性
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置项
});
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 其他配置项
});
// 通过 parse() 方法设置数据
this._kanban.parse({
columns,
cards,
rows
});
}
ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}
使用 parse(data)
方法可以随时重新加载数据。
这样,Kanban 组件就配置完成了。将该元素添加到页面后,Kanban 会以数据集初始化。您也可以根据需要调整任何配置项。所有可用属性请参考 Kanban API 文档。
事件处理
每当有人与 Kanban 交互时,都会触发一个事件。您可以利用这些事件跟踪操作并执行自定义代码。查看 完整事件列表 获取详细信息。
打开 kanban.component.ts,将 ngOnInit()
方法修改如下:
// ...
ngOnInit() {
this._kanban = new Kanban(this.kanban_container.nativeElement, {});
this._kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
}
ngOnDestroy(): void {
this._kanban.destructor();
}
步骤 3. 将 Kanban 添加到应用
要在您的应用中使用 KanbanComponent,请打开 src/app/app.component.ts,并将默认代码替换为:
import { Component } from "@angular/core";
@Component({
selector: "app-root",
template: `<kanban/>`
})
export class AppComponent {
name = "";
}
然后,在 src/app/ 下创建 app.module.ts,并声明 KanbanComponent:
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { AppComponent } from "./app.component";
import { KanbanComponent } from "./kanban/kanban.component";
@NgModule({
declarations: [AppComponent, KanbanComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}
最后,打开 src/main.ts,使用如下代码:
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));
此时,您可以启动应用,页面上将显示加载了数据的 Kanban。
以上就是 DHTMLX Kanban 与 Angular 集成的基本步骤。您可根据需求调整代码。更多高级示例请参考 GitHub。

跳至主要内容

与 Vue 集成

提示

在开始之前,建议你熟悉 Vue 的基本概念和模式。如果需要回顾,可以查看 Vue 3 文档

DHTMLX Kanban 与 Vue 配合良好。我们提供了一些代码示例,演示如何在 Vue 3 中使用 DHTMLX Kanban。更多细节请参阅 GitHub 示例

创建项目

信息

请确保已安装 Node.js,再开始新项目。

要创建一个 Vue 项目,请运行以下命令:

npm create vue@latest

此命令会安装并启动 create-vue,这是官方的 Vue 项目脚手架工具。更多信息可参见 Vue.js 快速开始

你可以将项目命名为 my-vue-kanban-app

安装依赖

进入你的应用文件夹:

cd my-vue-kanban-app

接下来,安装依赖并启动开发服务器。你可以选择使用不同的包管理器:

  • 如果使用 yarn,请运行:
yarn
yarn start // 或 yarn dev
  • 如果使用 npm,请运行:
npm install
npm run dev

应用现在应该已经在本地运行(例如在 http://localhost:3000)。

创建 Kanban

要开始使用 DHTMLX Kanban,首先需要获取源码。暂停应用并安装 Kanban 包。

步骤 1. 安装包

下载 试用版 Kanban 包,并按照 README 文件的指引进行操作。试用版有效期为 30 天。

步骤 2. 创建组件

接下来,在你的应用中通过 Vue 组件添加带有 Toolbar 的 Kanban。请在 src/components/ 下创建新文件 Kanban.vue

导入源文件

打开 Kanban.vue 并导入 Kanban 相关文件。方法如下:

  • 如果是 PRO 版本,并且你从本地文件夹安装 Kanban,导入路径如下:
Kanban.vue
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

如果你的包中带有压缩文件,请确保导入 kanban.min.css

  • 如果是试用版,请使用以下路径:
Kanban.vue
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

本指南演示如何设置 试用版 Kanban。

设置容器并添加带 Toolbar 的 Kanban

要展示 Kanban 和 Toolbar,先设置容器,并通过构造函数初始化这些组件:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
mounted() {
// 初始化 Kanban 组件
this.kanban = new Kanban(this.$refs.kanban_container, {});

// 初始化 Toolbar 组件
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api, // 提供 Kanban 内部 API
// 其他配置项
});
},

unmounted() {
this.kanban.destructor(); // 销毁 Kanban
this.toolbar.destructor(); // 销毁 Toolbar
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

添加样式

为确保 Kanban 正确显示,请在主 css 文件中为 Kanban 及其容器添加必要样式:

main.css
/* 页面初始样式 */
html,
body,
#app { /* 确保使用 #app 根容器 */
height: 100%;
padding: 0;
margin: 0;
}

/* Kanban 和 Toolbar 容器样式 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* Kanban 容器样式 */
.widget {
height: calc(100% - 56px);
}

加载数据

要为 Kanban 填充数据,请在 src/ 下创建 data.js 文件并添加一些示例数据:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/kanbans ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

然后,打开 App.vue,导入你的数据,并通过内部的 data() 方法进行设置。之后,将数据作为 props 传递给 <Kanban/> 组件:

App.vue
<script>
import Kanban from "./components/Kanban.vue";
import { getData } from "./data";

export default {
components: { Kanban },
data() {
const { columns, cards, rows } = getData();
return {
columns,
cards,
rows
};
}
};
</script>

<template>
<Kanban :columns="columns" :cards="cards" :rows="rows"/>
</template>

现在在 Kanban.vue 中,将这些 props 应用于 Kanban 的配置对象:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
cards: this.cards,
columns: this.columns,
rows: this.rows,
rowKey: "type",
// 其他配置项
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// 其他配置项
});
},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

你也可以在 Vue 的 mounted() 中使用 parse() 方法加载数据到 Kanban:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置项
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// 其他配置项
});

this.kanban.parse({
cards: this.cards,
columns: this.columns,
rows: this.rows
});
},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

parse(data) 方法会在每次数据变更时重新加载数据。

此时,Kanban 组件已经准备就绪。只要将该组件添加到页面,它就会用你的数据进行初始化。你还可以根据需要添加更多配置。查看所有可用属性,请参考 Kanban API 文档

事件处理

每当 Kanban 上有操作发生时,都会触发一个事件。你可以利用这些事件来响应用户行为。完整事件列表请见 事件文档

打开 Kanban.vue,如下更新 mounted() 方法:

Kanban.vue
<script>
// ...
export default {
// ...
mounted() {
this.kanban = new Kanban(this.$refs.cont, {});

this.kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
},

unmounted() {
this.kanban.destructor();
}
}
</script>

// ...

现在你可以启动应用,查看带数据的 Kanban 看板。

Kanban initialization

这就是 DHTMLX Kanban 与 Vue 集成的全部步骤。你可以根据需要调整和扩展代码。更多高级示例见 GitHub

跳至主要内容

与 React 集成

提示

在深入阅读本篇文档之前,建议您先了解 React 的基础知识。如果您想复习 React,可以访问 React 官方文档

DHTMLX Kanban 与 React 配合良好。文档中提供了在 React 项目中使用 DHTMLX Kanban 的代码示例。详细内容请参考 GitHub 示例

创建项目

信息

在开始新项目之前,请确保已安装 Vite(可选)和 Node.js

您可以从标准的 React 项目开始,或使用 React 和 Vite 进行搭建。本指南以 my-react-kanban-app 为例:

npx create-react-app my-react-kanban-app

安装依赖

切换到应用程序目录:

cd my-react-kanban-app

添加依赖并运行开发服务器。您可以选择喜欢的包管理器:

yarn
yarn start
npm install
npm run dev

应用通常会在本地 http://localhost:3000 可访问。

创建 Kanban

接下来,获取 DHTMLX Kanban 源码。首先停止应用并安装 Kanban 包。

第一步:安装包

下载 试用版 Kanban 包,并按照其 README 文件中的说明进行操作。请注意,试用版可用 30 天。

第二步:创建组件

新建一个 React 组件,将 Kanban 看板添加到您的应用中。在 src/ 目录下新建文件 Kanban.jsx

导入源文件

打开 Kanban.jsx 并导入 Kanban 源文件。注意以下事项:

  • 本地安装的 PRO 版本,导入方式如下:
Kanban.jsx
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';

根据包的不同,CSS 文件可能已被压缩,此时请使用 kanban.min.css

  • 试用版请使用以下导入路径:
Kanban.jsx
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import "@dhx/trial-kanban/dist/kanban.css";

本指南以 试用版 为例进行说明。

设置容器并添加 Kanban 和 Toolbar

要在页面上显示带 Toolbar 的 Kanban,请为二者设置容器并用各自的构造函数初始化:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css'; // 引入 Kanban 样式

export default function KanbanComponent(props) {
let toolbar_container = useRef(); // 初始化 Toolbar 容器
let kanban_container = useRef(); // 初始化 Kanban 容器

useEffect(() => {
// 初始化 Kanban 组件
const kanban = new Kanban(kanban_container.current, {});

// 初始化 Toolbar 组件
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api, // 提供 Kanban 内部 API
// 其他配置项
});

return () => {
kanban.destructor(); // 销毁 Kanban
toolbar.destructor(); // 销毁 Toolbar
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

添加样式

为保证 Kanban 正确显示,请在主 CSS 文件中添加以下关键样式:

index.css
/* 初始化页面样式 */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* Kanban 和 Toolbar 容器样式 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* Kanban 容器样式 */
.widget {
height: calc(100% - 56px);
}

加载数据

要在 Kanban 中显示数据,需要准备一个数据集。在 src/ 下新建 data.js 文件,并添加如下内容:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

现在,在 App.js 中导入数据,并通过 props 传递给 <Kanban/> 组件:

App.js
import Kanban from "./Kanban";
import { getData } from "./data";

function App() {
const { columns, cards, rows } = getData();
return <Kanban columns={columns} cards={cards} rows={rows} />;
}

export default App;

Kanban.jsx 中,使用 props 配置 Kanban:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: props.columns, // 设置列数据
cards: props.cards, // 设置卡片数据
rows: props.rows, // 设置行数据
rowKey: "type",
// 其他配置项
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// 其他配置项
});

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

如果希望在 useEffect() 内部使用 parse() 方法加载数据,方式如下:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

let columns = props.columns; // 列数据
let cards = props.cards; // 卡片数据
let rows = props.rows; // 行数据

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 其他配置项
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// 其他配置项
});

kanban.parse({ columns, cards, rows });

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

通过使用 parse(data) 方法,可以在数据变化时重新加载 Kanban。

至此,Kanban 组件已搭建完成。渲染后将根据您的数据进行初始化,您可按需添加更多配置。更多设置请查看 Kanban API 文档

事件处理

用户在 Kanban 上的操作会触发不同的事件。通过这些事件,您可以响应用户行为并执行自定义代码。完整事件列表见文档:事件总览

以下是在 Kanban.jsx 中设置简单事件处理的示例:

Kanban.jsx
// ...
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {});

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});

return () => {
kanban.destructor();
};
}, []);
// ...

现在只需运行应用,即可看到已加载数据的 Kanban 看板。

Kanban initialization

通过以上步骤,DHTMLX Kanban 已成功集成进 React。您可根据实际需求调整代码。如需进阶示例,请访问 GitHub